/* (C) 2022 YiRing, Inc. */
package com.yiring.app.excel.user;

import cn.hutool.core.date.LocalDateTimeUtil;
import com.github.liaochong.myexcel.core.annotation.ExcelColumn;
import com.yiring.app.vo.user.UserVo;
import java.io.Serial;
import java.io.Serializable;
import java.util.List;
import java.util.stream.Collectors;
import lombok.*;
import lombok.experimental.FieldDefaults;

/**
 * 部门信息控制器
 *
 * @author LJ-2204
 * @date 2022/4/24
 */

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@FieldDefaults(level = AccessLevel.PRIVATE)
public class UserExportExcel implements Serializable {

    @Serial
    private static final long serialVersionUID = 7104402721241163991L;

    @ExcelColumn(title = "真实姓名")
    String realName;

    @ExcelColumn(title = "创建时间")
    String createTime;

    public static List<UserExportExcel> transforms(List<UserVo> userVos) {
        return userVos
            .stream()
            .map(userVo ->
                UserExportExcel
                    .builder()
                    .realName(userVo.getRealName())
                    .createTime(LocalDateTimeUtil.format(userVo.getCreateTime(), "yyyy-MM-dd HH:mm:ss"))
                    .build()
            )
            .collect(Collectors.toList());
    }
}
