/* (C) 2022 YiRing, Inc. */
package com.yiring.app.feign;

import com.alibaba.fastjson.JSONObject;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

@FeignClient(url = "api.weixin.qq.com", name = "wxclient")
public interface WxClient {
    /**
     * 获取微信用户唯一标识
     *
     * @param appid String
     * @param secret String
     * @param js_code String
     * @param grant_type String
     * @return com.alibaba.fastjson.JSONObject
     * @author tzl
     * @date 15:20
     */
    @RequestMapping(value = "/sns/jscode2session", method = RequestMethod.GET)
    @ApiImplicitParams(
        {
            @ApiImplicitParam(value = "appid", required = true, name = "appid"),
            @ApiImplicitParam(value = "secret", required = true, name = "secret"),
            @ApiImplicitParam(value = "js_code", required = true, name = "js_code"),
            @ApiImplicitParam(value = "grant_type", required = true, name = "grant_type"),
        }
    )
    JSONObject getOpenid(String appid, String secret, String js_code, String grant_type);
}
