/* (C) 2022 YiRing, Inc. */
package com.yiring.auth.util;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.extra.spring.SpringUtil;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSON;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import lombok.experimental.UtilityClass;
import org.springframework.data.redis.core.RedisTemplate;

/**
 * 真源授权工具
 * @author LJ-2204
 * @date 2022/4/15
 */

@UtilityClass
public class ZyUtil {

    RedisTemplate<String, Object> redisTemplate;

    static {
        redisTemplate = SpringUtil.getBean("redisTemplate");
    }

    public final String CLIENT_ID = "sc21080400";

    public final String CLIENT_SECRET = "12A14FDC";

    public final String GRANT_TYPE = "client_credentials";

    public final String KEY = "zy_token";

    /**
     * 获取token
     * @return token
     */
    public static String login() {
        Object obj = redisTemplate.opsForValue().get(KEY);
        if (ObjectUtil.isNotEmpty(obj)) {
            return String.valueOf(obj);
        }
        Map<String, Object> map = MapUtil.createMap(HashMap.class);
        map.put("client_id", CLIENT_ID);
        map.put("client_secret", CLIENT_SECRET);
        map.put("grant_type", GRANT_TYPE);
        String json = HttpUtil.get("http://project.yz-online.com:789/positionApi/oauth/token", map);
        Map result = JSON.parseObject(json, Map.class);
        String access_token = result.get("access_token").toString();
        String expires_in = result.get("expires_in").toString();
        redisTemplate.opsForValue().set(KEY, access_token, Convert.toInt(expires_in), TimeUnit.SECONDS);
        return access_token;
    }

    /**
     * 判断token是否有效
     * @return T/F
     */
    public static boolean getToken() {
        return ObjectUtil.isNotEmpty(redisTemplate.opsForValue().get(KEY));
    }
}
